use std::ops::{Index, IndexMut};

pub trait Vector:
    Index<usize, Output = Self::T> + IndexMut<usize, Output = Self::T> + Clone + From<Vec<Self::T>>
{
    type T;

    fn len(&self) -> usize;
    fn from_value(i: usize, v: Self::T) -> Self; //TODO: maybe v should be &Self::T ?
    fn get_unchecked_mut(&mut self, i: usize) -> &mut Self::T {
        &mut self[i]
    }
    fn zeros(i: usize) -> Self;
}
