use algpath::{
    flint::{Acb, AcbMat, AcbVec},
    traits::{matrix::Matrix, vector::Vector, Interval},
};
use num_traits::{One, Zero};

#[test]
fn index() {
    let m = 20;
    let n = 10;
    let mat = AcbMat::zeros(m, n);
    println!("{:?}", mat[(3, 4)]);
}

#[test]
fn index_mut() {
    let m = 20;
    let n = 10;
    let mut mat = AcbMat::zeros(m, n);
    mat[(3, 4)] = Acb::square(2.0);
    println!("{:?}", mat[(3, 4)]);
}

// #[test]
// fn iter() {
//     let m = 20;
//     let n = 10;
//     let mat = AcbMat::zeros(m, n);
//     mat.into_iter().for_each(|c| assert!(c.is_zero()));
// }

// #[test]
// fn iter_mut() {
//     let m = 2;
//     let mut mat = AcbMat::id(m);
//     (&mut mat).into_iter().for_each(|c| c.set_zero());
//     println!("{:?}", mat);
//     mat.into_iter().for_each(|c| assert!(c.is_zero()));
// }

#[test]
fn mul() {
    let n = 3;
    let v = AcbVec::from_value(n, Acb::one());
    let mat = AcbMat::id(n);
    println!("{:?}", mat);
    println!("{:?}", &mat * v);
}

#[test]
fn from_vec() {
    let v: Vec<Acb> = vec![(-3).into(), 2025.into(), (-123456).into()];
    let mat = AcbMat::from_vec(3, 2, v);
    assert!((0..2).all(|i| mat[(i, 1)].is_zero())); // Check that the second column is filled with zeros
    println!("{:?}", mat);
}
